VelocityReport Plugin - Defect #1318

VelocityReportPlugin v3.5.54 Pie Chart not show in Smart/Web Client
03/27/2018 09:55 AM - Javier Arroyo

Status: Rejected Start date: 03/27/2018
Priority: Normal Due date:

Assignee: Javier Arroyo % Done: 0%
Category: Estimated time: 0.00 hour

Target version:

Browser (if web
client):

Description
After the upgrade to Servoy 8.2.3 the Velocity Plugin PieChart/BarChart not show in my Html Area

var myPie = plugins.VelocityReport.getChart(CHART.PIE, getPieChartDef(dataset));
var html = '<html><body>'+myPie+'</body></html>';

function getPieChartDef(dataset) {

var year = forms.FrmFacturasGC.fecha_cfa.getFullYear()
var vquery = "select cli.DescCliente, SUM "+

"from [tbFacturaCabecera] oi LEFT JOIN "+
"[tbMaestroClientes] cli ON oi.clie_cfa = cli.IdCliente "+
"where year(fecha_cfa) = "+year+

" group by cli.DescCliente order by 2 desc";

var result = databaseManager.getDataSetByQuery(globals.GCconex,vquery,null,-1)
var chartDef = {};

chartDef title = "Top 5 Clientes ("+year+")";
chartDef.threeD = true;

chartDef.shadow = true;

chartDef.proportional = true;

chartDef.labelFontSize = 12;

chartDef.width = elements.html.getWidth() - 10/*360%/;
chartDef.height= elements.html.getHeight() - 10;
chartDef.legendPosition = "right";
chartDef.legendMargins = {horizontal: 10, vertical: 2};
chartDef.margins = {top: 10, left: 10, right: 10, bottom: 10};
chartDef.slices = new Array();

var maxRows = dataset.getMaxRowIndex()

/** @type String */

var totalLine = dataset.getColumnAsArray(2)

totalLine = totalLine.join('+")

totalLine = eval(totalLine);

for(var i=1; i <= maxRows; i++)

{

result.rowIndex = 1i;
var percent = dataset.getValue(i,?2);
var text = dataset.getValue(i,1l);
var color = Colores[i-1];
var porc = (percent * 100)/totalline;
var slice = { percent: percent, label: utils.numberFormat (porc, '###,##0.00')+'%', legend:
text , color: color };
chartDef.slices.push(slice);
}
chartDef.orientation = 45;
//etc.
return chartDef;
}
History
#1 - 03/27/2018 05:31 PM - Patrick Talbot
- Status changed from New to Feedback

- Assignee set to Javier Arroyo

Do you have the eastwood.war correctly deployed?
Is there any exception in the log?

#2 - 03/28/2018 08:12 AM - Javier Arroyo

I think | deploy correctly eastwood.war. The first thing | have done is to stop application server, replace beans, plugins,... of new version, delete the
eastwwod.war and eastwood folder of previous version. Then | put eastwood.war of version 3.5.54, and reboot application server.

There is not any exception in the log.

#3 - 03/28/2018 07:26 PM - Patrick Talbot

| don't understand your script. You are passing a dataset (dataset), then you are querying another (result), then you are updating the result.rowindex
but getting values from the dataset you passed. Doesn't make too much sense to me.

Could you send me a JSON output of the chartDef object?

#4 - 04/03/2018 10:01 AM - Javier Arroyo

The output of chartDef object:

<img
src="http://localhost:8080/eastwood/chart?cht=p3&chdlp=r&chp=45.0&chs=362x1918&chts=000000,12&chd=e%3AiRODHLETEN&chma=10,10,10,10
%7C10,2&chtt=Top+5+Clientes+%282018%29&chco=0080FF,00CC66,FF0000,FFFF00,CCCCCC&chl=53%2C55%25%7C21%2C95%25%7C11%2

C22%25%7C6%2C72%25%7C6%2C57%25&chdI=BURNIGAI+S.A.L%7CINDUSTRIAS+GOL%2C+S.A.U.%7CTESOLVIT+%2C+S.L.%7CTROFEO
S+ZUSI%2C+S.L.%7CTALLERES+MENDIZABAL&Ifs=12&3d=1&xp=1&ewr=1" border="0" class="chart" width="362" height="191"></img>

There is not any exception in the log, but the Pie chart not show.

#5 - 04/11/2018 12:07 PM - Javier Arroyo
Any reason why Pie Chart not show in Smart/Web Client??

#6 - 04/26/2018 03:34 PM - Patrick Talbot
- File chart.png added

| just tried in Servoy 8.2.3 and Velocity 3.5.55 with the exact URL you've provided above:

http://localhost:8080/eastwood/chart?cht=p3&chdlp=r&chp=45.0&chs=362x191&chts=000000,12&chd=e%3AiIRODHLETEN&chma=10,10,10,10%7C
10,2&chtt=Top+5+Clientes+%282018%29&chco=0080FF,00CC66,FF0000,FFFF00,CCCCCC&chl=53%2C55%25%7C21%2C95%25%7C11%2C22
%25%7C6%2C72%25%7C6%2C57%25&chdl=BURNIGAI+S.A.L%7CINDUSTRIAS+GOL%2C+S.A.U.%7CTESOLVIT+%2C+S.L.%7CTROFEOS+Z
USI%2C+S.L.%7CTALLERES+MENDIZABAL&Ifs=12&3d=1&xp=1&ewr=1

And it worked fine for me, producing the chart image attached.

Could it be because of the new sanitizer that Servoy uses to strip some data from HTML_AREA?

I've seen this in one solution with WebClient where | had to use the WebClientUtils to push tags like <input> in an area. What you need to do is make
sure your dataprovider starts with "<html><head></head><body>" and ends with "</body></html>" otherwise Servoy strips the tags, and in Smart

client, doesn't recognize the output as HTML...

So your HTML should be
'<html><head></head><body>'+myPie+'</body></html>";

#7 - 11/15/2018 12:42 PM - Javier Arroyo
Still unable to show Pie Chart, Bar Chart,.... in Smart/Web Client.
Even in the example application VelocityReport.servoy,which is included in the plugin, the different charts are not shown correctly.

For example the output of PiechartDef object is:

<img
src="http://localhost:8080/eastwood/chart?cht=p3&chdlp=r&chp=45.0&chs=600x300&chts=222222,18&chd=e%3AS4QAJ7GiMr&chma=10,10,10,10
%7C10,2&chtt=My+fantastic+Pie%21&chf=bg,lg,90,CCCCCC,0.0,FFFFFF,1.0&chco=FF0000,00FF00,0000FF,FFOOFF,00FFFF&chl=Thirty%7CTwen
ty-Five%7CFifteen%7CFive%7CTwenty&chdl=Thirty%7CTwenty-Five%7CFifteen%7CFive%7CTwenty&lfs=10&xp=1&ewr=1" border="0"
class="chart" width="600" height="300"></img>

But it is not displayed correctly

04/27/2025 2/3



#8 - 11/15/2018 05:02 PM - Patrick Talbot

As | said before, your example (and the sample solution) is working fine for me in Servoy 8+ (including 8.3.2 which | just tested), with Java 7 and 8, so

there must be something in your installation that prevents it to work fine.
For example, did you setup correctly the velocityReport.reportFolder and velocityReport.serverURL in the plugin page of servoy-admin?
Can you navigate to http://localhost:8080/eastwood/index.html in a browser? Do you get an HTTP error or do you see the Barcode test page?

#9 - 11/16/2018 12:29 PM - Javier Arroyo

| setup correctly the velocityReport.reportFolder and velocityReport.serverURL

-velocityreport.serverURL: http:/localhost:8080/
-velocityreport.reportfolder: C:/Servoy/Reports

| can’t navigate to http://localhost:8080/eastwood/index.html in a browser. | get error HTTP State 404 - /eastwood/index.html
The required resource is not available.

| see that in \\application_server\\server\\webapps | have eastwood.war and deployed the eastwood folder

What can | be doing wrong?

#10 - 11/16/2018 05:40 PM - Patrick Talbot

- File manager.war added

Not quite sure what you did wrong, but if you can't see a page in your browser when navigating to this URL then charts will not work either.
| would try and install the manager application, to see if the eastwood war, although it is deployed) is activated.

When Developer is not started, put the attached manager.war in your /server/webapps

Also create a user in server/conf/tomcat-users.xml like:

<tomcat-users>

<role rolename="manager"/>

<role rolename="manager-gui"/>

<role rolename="manager-status"/>

<user username="servoy" password="servoy" roles="manager,manager-gui,manager-status"/>

</tomcat-users>

Then start Servoy and you should be able to navigate to http://localhost:8080/manager/html and see if the /eastwood war is active.

#11 - 11/20/2018 02:44 PM - Javier Arroyo

| followed your instructions, put the attached manager.war in your /server/webapps and create a user in server/conf/tomcat-users.xml as you
explained.

Then start Servoy and navigate to http://localhost:8080/manager/html. Ask for username and password. | put username="servoy" password="servoy"

as it was created in server/conf/tomcat-users.xml, but | get error 401 Unauthorized You are not authorized to view this page.

It seems that .war (eastwood.war, manager.war) are deployed but not activated and therefore are not accessible. Any idea why this happens and how

to solve it?

#12 - 11/20/2018 03:58 PM - Patrick Talbot

| have no idea why war files wouldn't be activated. The manager is supposed to give you access to the various "applications” (wars and servlet paths)

deployed and install/activate. If you cannot even access the manager, | fear there is something very wrong with your installation...

| would recommend doing a clean install of Servoy.

#13 - 02/28/2019 10:02 PM - Patrick Talbot
- Status changed from Feedback to Rejected

Files

Captura__1_.JPG 20.1 KB 03/27/2018 Javier Arroyo

Captura2.JPG 17.1 KB 03/27/2018 Javier Arroyo

chart.png 9.89 KB 04/26/2018 Patrick Talbot

manager.war 26.8 KB 11/16/2018 Patrick Talbot
